VERSION 5.00
Begin VB.Form frmConvert 
   Caption         =   "Number Conversions"
   ClientHeight    =   2430
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6585
   LinkTopic       =   "Form1"
   ScaleHeight     =   2430
   ScaleWidth      =   6585
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txt 
      Height          =   285
      Index           =   8
      Left            =   1320
      TabIndex        =   7
      Top             =   1680
      Width           =   4815
   End
   Begin VB.TextBox txt 
      Height          =   285
      Index           =   16
      Left            =   1320
      TabIndex        =   5
      Top             =   1200
      Width           =   4815
   End
   Begin VB.TextBox txt 
      Height          =   285
      Index           =   2
      Left            =   1320
      TabIndex        =   3
      Top             =   720
      Width           =   4815
   End
   Begin VB.TextBox txt 
      Height          =   285
      Index           =   10
      Left            =   1320
      TabIndex        =   1
      Top             =   240
      Width           =   4815
   End
   Begin VB.Label lbl 
      Caption         =   "&Octal"
      Height          =   255
      Index           =   3
      Left            =   240
      TabIndex        =   6
      Top             =   1680
      Width           =   975
   End
   Begin VB.Label lbl 
      Caption         =   "&Hexadecimal"
      Height          =   255
      Index           =   2
      Left            =   240
      TabIndex        =   4
      Top             =   1200
      Width           =   975
   End
   Begin VB.Label lbl 
      Caption         =   "&Binary"
      Height          =   255
      Index           =   1
      Left            =   240
      TabIndex        =   2
      Top             =   720
      Width           =   975
   End
   Begin VB.Label lbl 
      Caption         =   "&Decimal"
      Height          =   255
      Index           =   0
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   975
   End
End
Attribute VB_Name = "frmConvert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim mintSource As Integer

Private Sub txt_Change(Index As Integer)

    Dim dblValue As Double, dblTemp As Double, dblDecimal As Double
    Dim strValue As String, strChar As String, strWord As String
    Dim i As Integer, intTemp As Integer

    'This if statement keeps one text boxes change event from firing this
    'event for another text boxes change event.
    If Index = mintSource Then

        'Convert the number to a double, which allows values up to 9*10^15
        strValue = txt(Index).Text
        For i = 1 To Len(strValue)
            strChar = Mid(strValue, i, 1)
            If strChar <> " " Then
                If strChar <= "9" Then
                    dblValue = dblValue + CInt(strChar)
                Else
                    dblValue = dblValue + ((Asc(strChar) - 55) Mod 32)
                End If
                If i < Len(strValue) Then dblValue = dblValue * Index
            End If
        Next i

        'Base 10 box just gets the value, unless it is what the user is changing
        If Index <> 10 Then txt(10).Text = CStr(dblValue)

        'Base 2 box we need to convert the number to binary by using mod
        'and integer division.  Since mod only works on integers, we must break
        'the number up into 8 bit chunks by dividing it by 256 repeatedly
        'taking the decimal portion and figure out how many 256ths it represents.
        If Index <> 2 Then
            strValue = ""
            dblTemp = dblValue
            Do While dblTemp >= 1
                dblTemp = dblTemp / 256
                dblDecimal = dblTemp - Fix(dblTemp)
                dblTemp = Fix(dblTemp)
                intTemp = Int(dblDecimal * 256 + 0.5)
                strWord = ""
                'For any bit, intTemp\(2^i) will be 1 if its on, 0 if its off
                'but then we must turn that bit off for the next bit to work
                'which is why we do intTemp=intTemp mod (2^i)
                For i = 7 To 0 Step -1
                    strWord = strWord & CStr(intTemp \ (2 ^ i))
                    intTemp = intTemp Mod (2 ^ i)
                Next
                strValue = strWord & " " & strValue
            Loop
            txt(2).Text = LTrim$(strValue)
        End If

        'Base 8 box we need to convert the number to octal by using mod
        'and integer division.  Since mod only works on integers, we must break
        'the number up into 8 bit chunks by dividing it by 4096 repeatedly
        'taking the decimal portion and figure out how many 4096ths it represents.
        If Index <> 8 Then
            strValue = ""
            dblTemp = dblValue
            Do While dblTemp >= 1
                dblTemp = dblTemp / 4096
                dblDecimal = dblTemp - Fix(dblTemp)
                dblTemp = Fix(dblTemp)
                intTemp = Int(dblDecimal * 4096 + 0.5)
                strWord = ""
                For i = 3 To 0 Step -1
                    strWord = strWord & CStr(intTemp \ (8 ^ i))
                    intTemp = intTemp Mod (8 ^ i)
                Next
                strValue = strWord & " " & strValue
            Loop
            txt(8).Text = LTrim$(strValue)
        End If

        'Base 16 box we need to convert the number to hex by using mod
        'and integer division.  Since mod only works on integers, we must break
        'the number up into 8 bit chunks by dividing it by 256 repeatedly
        'taking the decimal portion and figure out how many 256ths it represents.
        If Index <> 16 Then
            strValue = ""
            dblTemp = dblValue
            Do While dblTemp >= 1
                dblTemp = dblTemp / 256
                dblDecimal = dblTemp - Fix(dblTemp)
                dblTemp = Fix(dblTemp)
                intTemp = Int(dblDecimal * 256 + 0.5)
                i = intTemp \ 16
                If i < 10 Then
                    strWord = CStr(i)
                Else
                    strWord = Chr(55 + i)
                End If
                i = intTemp Mod 16
                If i < 10 Then
                    strWord = strWord & CStr(i)
                Else
                    strWord = strWord & Chr(55 + i)
                End If
                strValue = strWord & " " & strValue
            Loop
            txt(16).Text = LTrim$(strValue)
        End If

    End If

End Sub

Private Sub txt_GotFocus(Index As Integer)
    txt(Index).SelStart = 0
    txt(Index).SelLength = Len(txt(Index))
End Sub

Private Sub txt_KeyPress(Index As Integer, KeyAscii As Integer)
'Generic key press validation to work on any base, which is represented
'by the Index of the text box

    mintSource = Index      'Save the source to prevent circular calls

    If KeyAscii = 8 Then Exit Sub                       'Backspace always OK
    If KeyAscii = 48 Or KeyAscii = 49 Then Exit Sub     '0 and 1 always OK

    If Index <= 10 Then     'Only numeric values acceptable
        'This if statements limits input to 0,1 for Index=2; 0 to 7 for Index=8...
        If (KeyAscii >= 48 + Index) Or (KeyAscii < 48) Then
            KeyAscii = 0
            Beep
        End If
    Else                    'Hexadecimal accepts all numbers and certain letters
        If KeyAscii >= 48 And KeyAscii <= 57 Then Exit Sub   'Numbers are OK
        If (KeyAscii >= 65) And (KeyAscii <= 54 + Index) Then Exit Sub
        If (KeyAscii >= 97) And (KeyAscii <= 86 + Index) Then Exit Sub
        KeyAscii = 0
        Beep
    End If

End Sub

